{*******************************************************}
{                                                       }
{       Borland Delphi Visual Component Library         }
{                                                       }
{  Copyright (c) 1995-2001 Borland Software Corporation }
{                                                       }
{*******************************************************}

unit xlsreg;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  DesignIntf, DesignEditors,
{$ELSE}
{$ENDIF}
{$IFDEF FPC}
  PropEdits,
{$ENDIF}


  SysUtils, Classes, artreport;

type
  TArtDataFieldProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    function GetDataSourcePropName: string; virtual;
    procedure GetValueList(List: TStrings);
  end;

  TMasterFieldProperty = class(TArtDataFieldProperty)
  public
    function GetDataSourcePropName: string; override;
  end;

  TDetailFieldProperty = class(TArtDataFieldProperty)
  public
    function GetDataSourcePropName: string; override;
  end;

  TSubdetailFieldProperty = class(TArtDataFieldProperty)
  public
    function GetDataSourcePropName: string; override;
  end;


procedure Register;

implementation

uses
{$IFNDEF FPC}
  DsnDBCst, Mask,
{$ELSE}
  MaskEdit, LResources,
{$ENDIF}
  Windows, Controls, Forms, TypInfo, DB,
  ActnList, ExcelPvd, CalcPvd;


function TArtDataFieldProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList];
end;

procedure TArtDataFieldProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    GetValueList(Values);
    for I := 0 to Values.Count - 1 do Proc(Values[I]);
  finally
    Values.Free;
  end;
end;

function TArtDataFieldProperty.GetDataSourcePropName: string;
begin
  Result := 'DataSource';
end;

function TMasterFieldProperty.GetDataSourcePropName: string;
begin
  Result := 'MasterSource';
end;

function TDetailFieldProperty.GetDataSourcePropName: string;
begin
  Result := 'DetailSource';
end;

function TSubDetailFieldProperty.GetDataSourcePropName: string;
begin
  Result := 'SubDetailSource';
end;

procedure TArtDataFieldProperty.GetValueList(List: TStrings);
var
  DataSource: TDataSource;
begin
  DataSource := GetObjectProp(GetComponent(0), GetDataSourcePropName) as TDataSource;
  if (DataSource <> nil) and (DataSource.DataSet <> nil) then
    DataSource.DataSet.GetFieldNames(List);
end;

{ Registration }

procedure Register;
begin
   RegisterPropertyEditor(TypeInfo(string), TArtReport, 'MasterField', TMasterFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtReport, 'DetailField', TDetailFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtReport, 'SubMasterField', TDetailFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtReport, 'SubDetailField', TSubDetailFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtReport, 'GroupField', TMasterFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtReport, 'SubGroupField', TMasterFieldProperty);
{$IFDEF ARTXLSREPORT} 
   RegisterPropertyEditor(TypeInfo(string), TArtXLSReport, 'MasterField', TMasterFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtXLSReport, 'DetailField', TDetailFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtXLSReport, 'SubMasterField', TDetailFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtXLSReport, 'SubDetailField', TSubDetailFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtXLSReport, 'GroupField', TMasterFieldProperty);
   RegisterPropertyEditor(TypeInfo(string), TArtXLSReport, 'SubGroupField', TMasterFieldProperty);
{$ENDIF}
   RegisterComponents('Art', [TARExcelProvider, TARCalcProvider]);
end;

{$IFDEF FPC}
initialization
     {$I tarexcelprovider.lrs}
     {$I tarcalcprovider.lrs}
{$ENDIF}

end.
